/*
 * generated by Xtext
 */
package fr.irisa.cairn.serializer;

import com.google.inject.Inject;
import fr.irisa.cairn.jniMap.AliasToClassMapping;
import fr.irisa.cairn.jniMap.ArrayType;
import fr.irisa.cairn.jniMap.BooleanType;
import fr.irisa.cairn.jniMap.CMethod;
import fr.irisa.cairn.jniMap.ClassDeclaration;
import fr.irisa.cairn.jniMap.ClassToClassMapping;
import fr.irisa.cairn.jniMap.ConstType;
import fr.irisa.cairn.jniMap.EnumDeclaration;
import fr.irisa.cairn.jniMap.EnumToClassMapping;
import fr.irisa.cairn.jniMap.EnumType;
import fr.irisa.cairn.jniMap.EnumValue;
import fr.irisa.cairn.jniMap.ExternalLibrary;
import fr.irisa.cairn.jniMap.FieldDef;
import fr.irisa.cairn.jniMap.GenericsDeclaration;
import fr.irisa.cairn.jniMap.GenericsInstantiation;
import fr.irisa.cairn.jniMap.Import;
import fr.irisa.cairn.jniMap.IncludeDef;
import fr.irisa.cairn.jniMap.IntegerType;
import fr.irisa.cairn.jniMap.InterfaceClass;
import fr.irisa.cairn.jniMap.InterfaceImplementation;
import fr.irisa.cairn.jniMap.JniMapPackage;
import fr.irisa.cairn.jniMap.Library;
import fr.irisa.cairn.jniMap.LibraryFileName;
import fr.irisa.cairn.jniMap.Mapping;
import fr.irisa.cairn.jniMap.Method;
import fr.irisa.cairn.jniMap.MethodGroup;
import fr.irisa.cairn.jniMap.ModifiableType;
import fr.irisa.cairn.jniMap.ParamDef;
import fr.irisa.cairn.jniMap.PtrType;
import fr.irisa.cairn.jniMap.RealType;
import fr.irisa.cairn.jniMap.StringType;
import fr.irisa.cairn.jniMap.StructDeclaration;
import fr.irisa.cairn.jniMap.StructToClassMapping;
import fr.irisa.cairn.jniMap.StructType;
import fr.irisa.cairn.jniMap.TypeAlias;
import fr.irisa.cairn.jniMap.TypeAliasDeclaration;
import fr.irisa.cairn.jniMap.UnmappedClass;
import fr.irisa.cairn.jniMap.UserModule;
import fr.irisa.cairn.jniMap.VoidType;
import fr.irisa.cairn.services.JniMapGrammarAccess;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public abstract class AbstractJniMapSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private JniMapGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == JniMapPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case JniMapPackage.ALIAS_TO_CLASS_MAPPING:
				sequence_AliasToClassMapping(context, (AliasToClassMapping) semanticObject); 
				return; 
			case JniMapPackage.ARRAY_TYPE:
				sequence_ArrayType(context, (ArrayType) semanticObject); 
				return; 
			case JniMapPackage.BOOLEAN_TYPE:
				sequence_BooleanType(context, (BooleanType) semanticObject); 
				return; 
			case JniMapPackage.CMETHOD:
				sequence_CMethod(context, (CMethod) semanticObject); 
				return; 
			case JniMapPackage.CLASS_DECLARATION:
				sequence_ClassDeclaration(context, (ClassDeclaration) semanticObject); 
				return; 
			case JniMapPackage.CLASS_TO_CLASS_MAPPING:
				sequence_ClassToClassMapping(context, (ClassToClassMapping) semanticObject); 
				return; 
			case JniMapPackage.CONST_TYPE:
				sequence_ConstType(context, (ConstType) semanticObject); 
				return; 
			case JniMapPackage.ENUM_DECLARATION:
				sequence_EnumDeclaration(context, (EnumDeclaration) semanticObject); 
				return; 
			case JniMapPackage.ENUM_TO_CLASS_MAPPING:
				sequence_EnumToClassMapping(context, (EnumToClassMapping) semanticObject); 
				return; 
			case JniMapPackage.ENUM_TYPE:
				sequence_EnumType(context, (EnumType) semanticObject); 
				return; 
			case JniMapPackage.ENUM_VALUE:
				sequence_EnumValue(context, (EnumValue) semanticObject); 
				return; 
			case JniMapPackage.EXTERNAL_LIBRARY:
				sequence_ExternalLibrary(context, (ExternalLibrary) semanticObject); 
				return; 
			case JniMapPackage.FIELD_DEF:
				sequence_FieldDef(context, (FieldDef) semanticObject); 
				return; 
			case JniMapPackage.GENERICS_DECLARATION:
				sequence_GenericsDeclaration(context, (GenericsDeclaration) semanticObject); 
				return; 
			case JniMapPackage.GENERICS_INSTANTIATION:
				sequence_GenericsInstantiation(context, (GenericsInstantiation) semanticObject); 
				return; 
			case JniMapPackage.IMPORT:
				sequence_Import(context, (Import) semanticObject); 
				return; 
			case JniMapPackage.INCLUDE_DEF:
				sequence_IncludeDef(context, (IncludeDef) semanticObject); 
				return; 
			case JniMapPackage.INTEGER_TYPE:
				sequence_IntegerType(context, (IntegerType) semanticObject); 
				return; 
			case JniMapPackage.INTERFACE_CLASS:
				sequence_InterfaceClass(context, (InterfaceClass) semanticObject); 
				return; 
			case JniMapPackage.INTERFACE_IMPLEMENTATION:
				sequence_InterfaceImplementation(context, (InterfaceImplementation) semanticObject); 
				return; 
			case JniMapPackage.LIBRARY:
				sequence_Library(context, (Library) semanticObject); 
				return; 
			case JniMapPackage.LIBRARY_FILE_NAME:
				sequence_LibraryFileName(context, (LibraryFileName) semanticObject); 
				return; 
			case JniMapPackage.MAPPING:
				sequence_Mapping(context, (Mapping) semanticObject); 
				return; 
			case JniMapPackage.METHOD:
				sequence_Method(context, (Method) semanticObject); 
				return; 
			case JniMapPackage.METHOD_GROUP:
				sequence_MethodGroup(context, (MethodGroup) semanticObject); 
				return; 
			case JniMapPackage.MODIFIABLE_TYPE:
				sequence_ModifiableType(context, (ModifiableType) semanticObject); 
				return; 
			case JniMapPackage.PARAM_DEF:
				sequence_ParamDef(context, (ParamDef) semanticObject); 
				return; 
			case JniMapPackage.PTR_TYPE:
				sequence_PtrType(context, (PtrType) semanticObject); 
				return; 
			case JniMapPackage.REAL_TYPE:
				sequence_RealType(context, (RealType) semanticObject); 
				return; 
			case JniMapPackage.STRING_TYPE:
				sequence_StringType(context, (StringType) semanticObject); 
				return; 
			case JniMapPackage.STRUCT_DECLARATION:
				sequence_StructDeclaration(context, (StructDeclaration) semanticObject); 
				return; 
			case JniMapPackage.STRUCT_TO_CLASS_MAPPING:
				sequence_StructToClassMapping(context, (StructToClassMapping) semanticObject); 
				return; 
			case JniMapPackage.STRUCT_TYPE:
				sequence_StructType(context, (StructType) semanticObject); 
				return; 
			case JniMapPackage.TYPE_ALIAS:
				sequence_TypeAlias(context, (TypeAlias) semanticObject); 
				return; 
			case JniMapPackage.TYPE_ALIAS_DECLARATION:
				sequence_TypeAliasDeclaration(context, (TypeAliasDeclaration) semanticObject); 
				return; 
			case JniMapPackage.UNMAPPED_CLASS:
				sequence_UnmappedClass(context, (UnmappedClass) semanticObject); 
				return; 
			case JniMapPackage.USER_MODULE:
				sequence_UserModule(context, (UserModule) semanticObject); 
				return; 
			case JniMapPackage.VOID_TYPE:
				sequence_VoidType(context, (VoidType) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     ClassMapping returns AliasToClassMapping
	 *     AliasToClassMapping returns AliasToClassMapping
	 *
	 * Constraint:
	 *     (
	 *         alias=TypeAliasDeclaration 
	 *         name=ID 
	 *         genericsDecl=GenericsDeclaration? 
	 *         (super=[ClassMapping|ID] genericsInstantiation=GenericsInstantiation?)? 
	 *         (interfaces+=InterfaceImplementation interfaces+=InterfaceImplementation*)?
	 *     )
	 */
	protected void sequence_AliasToClassMapping(ISerializationContext context, AliasToClassMapping semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns ArrayType
	 *     NestedType returns ArrayType
	 *     ComplexType returns ArrayType
	 *     ArrayType returns ArrayType
	 *
	 * Constraint:
	 *     base=BaseType
	 */
	protected void sequence_ArrayType(ISerializationContext context, ArrayType semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.ARRAY_TYPE__BASE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.ARRAY_TYPE__BASE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getArrayTypeAccess().getBaseBaseTypeParserRuleCall_0_0(), semanticObject.getBase());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Type returns BooleanType
	 *     BuiltInType returns BooleanType
	 *     BooleanType returns BooleanType
	 *     BaseType returns BooleanType
	 *
	 * Constraint:
	 *     name='boolean'
	 */
	protected void sequence_BooleanType(ISerializationContext context, BooleanType semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.BUILT_IN_TYPE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.BUILT_IN_TYPE__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getBooleanTypeAccess().getNameBooleanKeyword_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     CMethod returns CMethod
	 *
	 * Constraint:
	 *     (res=Type name=ID (params+=ParamDef params+=ParamDef*)?)
	 */
	protected void sequence_CMethod(ISerializationContext context, CMethod semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ClassDeclaration returns ClassDeclaration
	 *
	 * Constraint:
	 *     (name=ID fields+=FieldDef*)
	 */
	protected void sequence_ClassDeclaration(ISerializationContext context, ClassDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ClassMapping returns ClassToClassMapping
	 *     ClassToClassMapping returns ClassToClassMapping
	 *
	 * Constraint:
	 *     (class=ClassDeclaration name=ID super=[ClassMapping|ID]?)
	 */
	protected void sequence_ClassToClassMapping(ISerializationContext context, ClassToClassMapping semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns ConstType
	 *     NestedType returns ConstType
	 *     ConstType returns ConstType
	 *
	 * Constraint:
	 *     base=Type
	 */
	protected void sequence_ConstType(ISerializationContext context, ConstType semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.CONST_TYPE__BASE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.CONST_TYPE__BASE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getConstTypeAccess().getBaseTypeParserRuleCall_1_0(), semanticObject.getBase());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     TypeDeclaration returns EnumDeclaration
	 *     EnumDeclaration returns EnumDeclaration
	 *
	 * Constraint:
	 *     (name=ID (values+=EnumValue values+=EnumValue*)?)
	 */
	protected void sequence_EnumDeclaration(ISerializationContext context, EnumDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ClassMapping returns EnumToClassMapping
	 *     EnumToClassMapping returns EnumToClassMapping
	 *
	 * Constraint:
	 *     (enum_=EnumDeclaration name=ID)
	 */
	protected void sequence_EnumToClassMapping(ISerializationContext context, EnumToClassMapping semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.ENUM_TO_CLASS_MAPPING__ENUM_) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.ENUM_TO_CLASS_MAPPING__ENUM_));
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.CLASS_MAPPING__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.CLASS_MAPPING__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getEnumToClassMappingAccess().getEnum_EnumDeclarationParserRuleCall_0_0(), semanticObject.getEnum_());
		feeder.accept(grammarAccess.getEnumToClassMappingAccess().getNameIDTerminalRuleCall_2_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     EnumType returns EnumType
	 *     Type returns EnumType
	 *     ComplexType returns EnumType
	 *     BaseType returns EnumType
	 *
	 * Constraint:
	 *     name=[EnumDeclaration|ID]
	 */
	protected void sequence_EnumType(ISerializationContext context, EnumType semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.ENUM_TYPE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.ENUM_TYPE__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getEnumTypeAccess().getNameEnumDeclarationIDTerminalRuleCall_1_0_1(), semanticObject.eGet(JniMapPackage.Literals.ENUM_TYPE__NAME, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     EnumValue returns EnumValue
	 *
	 * Constraint:
	 *     (name=ID (value=INT | enumNext=EnumValue)?)
	 */
	protected void sequence_EnumValue(ISerializationContext context, EnumValue semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ExternalLibrary returns ExternalLibrary
	 *
	 * Constraint:
	 *     (library=[Library|ID] mapping=[Mapping|ID])
	 */
	protected void sequence_ExternalLibrary(ISerializationContext context, ExternalLibrary semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.EXTERNAL_LIBRARY__LIBRARY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.EXTERNAL_LIBRARY__LIBRARY));
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.EXTERNAL_LIBRARY__MAPPING) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.EXTERNAL_LIBRARY__MAPPING));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getExternalLibraryAccess().getLibraryLibraryIDTerminalRuleCall_1_0_1(), semanticObject.eGet(JniMapPackage.Literals.EXTERNAL_LIBRARY__LIBRARY, false));
		feeder.accept(grammarAccess.getExternalLibraryAccess().getMappingMappingIDTerminalRuleCall_3_0_1(), semanticObject.eGet(JniMapPackage.Literals.EXTERNAL_LIBRARY__MAPPING, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     FieldDef returns FieldDef
	 *
	 * Constraint:
	 *     (copy?='copyOnGet'? type=Type name=ID many?='many'?)
	 */
	protected void sequence_FieldDef(ISerializationContext context, FieldDef semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     GenericsDeclaration returns GenericsDeclaration
	 *
	 * Constraint:
	 *     (names+=ID names+=ID*)
	 */
	protected void sequence_GenericsDeclaration(ISerializationContext context, GenericsDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     GenericsInstantiation returns GenericsInstantiation
	 *
	 * Constraint:
	 *     (instanceNames+=ID instanceNames+=ID*)
	 */
	protected void sequence_GenericsInstantiation(ISerializationContext context, GenericsInstantiation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Import returns Import
	 *
	 * Constraint:
	 *     importURI=STRING
	 */
	protected void sequence_Import(ISerializationContext context, Import semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.IMPORT__IMPORT_URI) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.IMPORT__IMPORT_URI));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0(), semanticObject.getImportURI());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     IncludeDef returns IncludeDef
	 *
	 * Constraint:
	 *     include=STRING
	 */
	protected void sequence_IncludeDef(ISerializationContext context, IncludeDef semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.INCLUDE_DEF__INCLUDE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.INCLUDE_DEF__INCLUDE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getIncludeDefAccess().getIncludeSTRINGTerminalRuleCall_1_0(), semanticObject.getInclude());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Type returns IntegerType
	 *     BuiltInType returns IntegerType
	 *     IntegerType returns IntegerType
	 *     BaseType returns IntegerType
	 *
	 * Constraint:
	 *     (name='unsigned' | name='int' | name='long' | name='char')
	 */
	protected void sequence_IntegerType(ISerializationContext context, IntegerType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ClassMapping returns InterfaceClass
	 *     InterfaceClass returns InterfaceClass
	 *
	 * Constraint:
	 *     (name=ID genericsDecl=GenericsDeclaration? (interfaces+=InterfaceImplementation interfaces+=InterfaceImplementation*)?)
	 */
	protected void sequence_InterfaceClass(ISerializationContext context, InterfaceClass semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     InterfaceImplementation returns InterfaceImplementation
	 *
	 * Constraint:
	 *     (interface=[InterfaceClass|ID] genericsInstantiation=GenericsInstantiation?)
	 */
	protected void sequence_InterfaceImplementation(ISerializationContext context, InterfaceImplementation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     LibraryFileName returns LibraryFileName
	 *
	 * Constraint:
	 *     (os=HostType filename=STRING)
	 */
	protected void sequence_LibraryFileName(ISerializationContext context, LibraryFileName semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.LIBRARY_FILE_NAME__OS) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.LIBRARY_FILE_NAME__OS));
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.LIBRARY_FILE_NAME__FILENAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.LIBRARY_FILE_NAME__FILENAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getLibraryFileNameAccess().getOsHostTypeEnumRuleCall_0_0(), semanticObject.getOs());
		feeder.accept(grammarAccess.getLibraryFileNameAccess().getFilenameSTRINGTerminalRuleCall_2_0(), semanticObject.getFilename());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Library returns Library
	 *
	 * Constraint:
	 *     (name=STRING filenames+=LibraryFileName+)
	 */
	protected void sequence_Library(ISerializationContext context, Library semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Mapping returns Mapping
	 *
	 * Constraint:
	 *     (
	 *         imports+=Import* 
	 *         name=ID 
	 *         package=STRING? 
	 *         hosts+=HostType 
	 *         hosts+=HostType* 
	 *         externalLibraries+=ExternalLibrary* 
	 *         libraries+=Library* 
	 *         userModules+=UserModule* 
	 *         (classMapping+=ClassMapping | includes+=IncludeDef)+ 
	 *         methodGroups+=MethodGroup+
	 *     )
	 */
	protected void sequence_Mapping(ISerializationContext context, Mapping semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     MethodGroup returns MethodGroup
	 *
	 * Constraint:
	 *     (class=[ClassMapping|ID] methods+=Method+)
	 */
	protected void sequence_MethodGroup(ISerializationContext context, MethodGroup semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Method returns Method
	 *
	 * Constraint:
	 *     (
	 *         (
	 *             (
	 *                 constructor?='constructor' | 
	 *                 destructor?='destructor' | 
	 *                 instanceof?='instanceOf' | 
	 *                 static?='static' | 
	 *                 private?='private' | 
	 *                 protected?='protected' | 
	 *                 stub?='stub' | 
	 *                 arg=INT
	 *             )? 
	 *             (renamed?='rename' newname=ID)?
	 *         )+ 
	 *         res=Type 
	 *         name=ID 
	 *         (params+=ParamDef params+=ParamDef*)?
	 *     )
	 */
	protected void sequence_Method(ISerializationContext context, Method semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns ModifiableType
	 *     NestedType returns ModifiableType
	 *     ModifiableType returns ModifiableType
	 *
	 * Constraint:
	 *     (base=BaseType indir+='&')
	 */
	protected void sequence_ModifiableType(ISerializationContext context, ModifiableType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ParamDef returns ParamDef
	 *
	 * Constraint:
	 *     ((give?='give' | take?='take' | keep?='keep')? type=Type name=ID)
	 */
	protected void sequence_ParamDef(ISerializationContext context, ParamDef semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns PtrType
	 *     NestedType returns PtrType
	 *     PtrType returns PtrType
	 *
	 * Constraint:
	 *     (base=BaseType indir+='*'+ ignored?='ignored'?)
	 */
	protected void sequence_PtrType(ISerializationContext context, PtrType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns RealType
	 *     BuiltInType returns RealType
	 *     RealType returns RealType
	 *     BaseType returns RealType
	 *
	 * Constraint:
	 *     (name='float' | name='double')
	 */
	protected void sequence_RealType(ISerializationContext context, RealType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns StringType
	 *     BuiltInType returns StringType
	 *     StringType returns StringType
	 *     BaseType returns StringType
	 *
	 * Constraint:
	 *     name='string'
	 */
	protected void sequence_StringType(ISerializationContext context, StringType semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.BUILT_IN_TYPE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.BUILT_IN_TYPE__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getStringTypeAccess().getNameStringKeyword_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     TypeDeclaration returns StructDeclaration
	 *     StructDeclaration returns StructDeclaration
	 *
	 * Constraint:
	 *     (name=ID fields+=FieldDef*)
	 */
	protected void sequence_StructDeclaration(ISerializationContext context, StructDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ClassMapping returns StructToClassMapping
	 *     StructToClassMapping returns StructToClassMapping
	 *
	 * Constraint:
	 *     (struct=StructDeclaration name=ID super=[ClassMapping|ID]?)
	 */
	protected void sequence_StructToClassMapping(ISerializationContext context, StructToClassMapping semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns StructType
	 *     ComplexType returns StructType
	 *     StructType returns StructType
	 *     BaseType returns StructType
	 *
	 * Constraint:
	 *     name=[StructDeclaration|ID]
	 */
	protected void sequence_StructType(ISerializationContext context, StructType semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.STRUCT_TYPE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.STRUCT_TYPE__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getStructTypeAccess().getNameStructDeclarationIDTerminalRuleCall_1_0_1(), semanticObject.eGet(JniMapPackage.Literals.STRUCT_TYPE__NAME, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     TypeDeclaration returns TypeAliasDeclaration
	 *     TypeAliasDeclaration returns TypeAliasDeclaration
	 *
	 * Constraint:
	 *     (type=Type? name=ID)
	 */
	protected void sequence_TypeAliasDeclaration(ISerializationContext context, TypeAliasDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns TypeAlias
	 *     ComplexType returns TypeAlias
	 *     TypeAlias returns TypeAlias
	 *     BaseType returns TypeAlias
	 *
	 * Constraint:
	 *     alias=[TypeAliasDeclaration|ID]
	 */
	protected void sequence_TypeAlias(ISerializationContext context, TypeAlias semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.TYPE_ALIAS__ALIAS) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.TYPE_ALIAS__ALIAS));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getTypeAliasAccess().getAliasTypeAliasDeclarationIDTerminalRuleCall_0_1(), semanticObject.eGet(JniMapPackage.Literals.TYPE_ALIAS__ALIAS, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     ClassMapping returns UnmappedClass
	 *     UnmappedClass returns UnmappedClass
	 *
	 * Constraint:
	 *     (
	 *         abstract?='abstract'? 
	 *         name=ID 
	 *         genericsDecl=GenericsDeclaration? 
	 *         (super=[ClassMapping|ID] genericsInstantiation=GenericsInstantiation?)? 
	 *         (interfaces+=InterfaceImplementation interfaces+=InterfaceImplementation*)?
	 *     )
	 */
	protected void sequence_UnmappedClass(ISerializationContext context, UnmappedClass semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     UserModule returns UserModule
	 *
	 * Constraint:
	 *     (name=ID methods+=CMethod*)
	 */
	protected void sequence_UserModule(ISerializationContext context, UserModule semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns VoidType
	 *     BuiltInType returns VoidType
	 *     VoidType returns VoidType
	 *     BaseType returns VoidType
	 *
	 * Constraint:
	 *     name='void'
	 */
	protected void sequence_VoidType(ISerializationContext context, VoidType semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, JniMapPackage.Literals.BUILT_IN_TYPE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, JniMapPackage.Literals.BUILT_IN_TYPE__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getVoidTypeAccess().getNameVoidKeyword_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
}
